var join = require('path').join
  , _ = require('./_');

var configure = {

  _config: {
    middleware: []
  },

  _defaults: {
    paths: {
      controllers: '/app/controllers'
    }
  },

  _middleware: [{
    logger: { options: {} }
  }, {
    router: { options: {} }
  }, {
    error_handler: { options: {} }
  }],

  config: function () {
    this._config = _.extend(this._defaults, this._config);
    this._config.middleware.unshift(this._middleware.shift());
    this._config.middleware.push(this._middleware[0]);
    this._config.middleware.push(this._middleware[1]);
    return this._config;
  },

  user: function (path) {
    path = path || join(process.env.PWD, 'config', 'application');
    try {
      this._config = require(path);
    } catch (err) {
      throw err;
    }
    return this;
  }
};

exports = module.exports = configure;