exports = module.exports = function logger(options) {

  return function logger(req, res, next) {
    req._start = new Date();

    function log() {
      var statusColor;
      if (res.statusCode >= 500) {
        statusColor = 'red';
      } else if (res.statusCode >= 400) {
        statusColor = 'yellow';
      } else {
        statusColor = 'green';
      }

      res.removeListener('finish', log);
      res.removeListener('close', log);
      process.stdout.write((req.method + ' ').grey
                         + (req.url + ' ')
                         + (res.statusCode + ' ')[statusColor]
                         + ((new Date() - req._start) + 'ms ').grey
                         + '\n');
    }

    res.on('finish', log);
    res.on('close', log);
    next();
  };
};