var path = require('path')
  , url = require('url')
  , Route = require('./route');

var router = {

  get: function (path, responder) {
    this.register('GET', path, responder);
  },

  middleware: function (options) {

    return function (req, res, next) {
      var app = require(path.join(process.env.PWD, 'app'))
        , routes = router.routes[req.method || 'GET']
        , i = 0
        , len = routes.length;

      for (i; i < len; i += 1) {
        var route = routes[i]
          , found = route.pattern.exec(req.url);
        if (found) {
          app.controllers[route.controller][route.action](found[1], req, res);
        }
      }

      next();
    };
  },

  register: function (verb, path, responder) {
    verb = verb || 'GET';
    this.routes[verb].push(new Route(verb, path, responder));
  },

  routes: {
    GET: [],
    DELETE: [],
    PUT: [],
    POST: []
  }
};

exports = module.exports = router;